﻿/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using AO.Core;
using MySql.Data.MySqlClient;

namespace LoginEngine.QueryBase
{
    /// <summary>
    /// 
    /// </summary>
    class LoginPlayer
    {
        private int cbreedint, cprofint, zoneid;
        DataSet data1, data2;
        DataTable datat1, datat2;
        public byte[] name, breed, prof, zone;
        MySqlWrapper ms = new MySqlWrapper();

        /// <summary>
        /// 
        /// </summary>
        /// <param name="RecvLogin"></param>
        public void GetCharacterName(string RecvLogin)
        {
            try
            {
                string SqlQuery = "SELECT `Name`, `Breed`, `Profession` FROM `characters` WHERE Username = " + "'" + RecvLogin + "'";
                ms.MySqlRead(SqlQuery);
                MySqlDataAdapter mda = new MySqlDataAdapter(ms.mcom);
                data1 = new DataSet();
                mda.Fill(data1);
                datat1 = data1.Tables[0];
                ms.mcc.Close();
                foreach (DataRow datarow1 in datat1.Rows)
                {
                    this.name = Encoding.ASCII.GetBytes(datarow1["Name"].ToString().PadRight(11, '\u0000'));
                    this.cbreedint = int.Parse(datarow1["Breed"].ToString());
                    this.breed = BitConverter.GetBytes(cbreedint);
                    this.cprofint = int.Parse(datarow1["Profession"].ToString());
                    this.prof = BitConverter.GetBytes(cprofint);
                }
                ms.mcc.Close();
            }

            catch (Exception e)
            {
                Console.WriteLine("An Error Has Happend: " + e);
                return;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="RecvLogin"></param>
        public void GetCharacterZone(string RecvLogin)
        {
            try
            {
                string SqlQuery = "SELECT `ZoneID` FROM `characters` WHERE Username = " + "'" + RecvLogin + "'";
                ms.MySqlRead(SqlQuery);
                MySqlDataAdapter mda = new MySqlDataAdapter(ms.mcom);

                data2 = new DataSet();
                mda.Fill(data2);
                datat2 = data2.Tables[0];
                foreach (DataRow datarow2 in datat2.Rows)
                {
                    this.zoneid = int.Parse(datarow2["ZoneID"].ToString());
                    this.zone = BitConverter.GetBytes(zoneid);
                }
                ms.mcc.Close();
            }

            catch (Exception e)
            {
                Console.WriteLine("An Error Has Happend: " + e);
                return;
            }
        }
    }
}