﻿#region License
/*
Copyright (c) 2005-2008, CellAO Team

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the CellAO Team nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using AO.Core;
using System.IO;
using System.Net;
using MySql.Data.MySqlClient;
using CellAO_DB_Tool.Classes;

namespace CellAO_DB_Tool
{
    public partial class CellAO_DB_Tool : Form
    {
        public CellAO_DB_Tool()
        {
            InitializeComponent();
        }

        LoginEngine le = new LoginEngine();
        #region Load Tool...
        private void CellAO_DB_Tool_Load(object sender, EventArgs e)
        {
            this.Name = "CellAO Admin Tool";
            bx_CreationTD.Text = DateTime.Now.ToString();
            string SqlQuery = "SELECT `Username` FROM `login`";
            MySqlWrapper ms = new MySqlWrapper();
            ms.MySqlRead(SqlQuery);
            MySqlDataAdapter mda = new MySqlDataAdapter(ms.mcom);
            ms.mcc.Close();
            DataSet ds = new DataSet();
            mda.Fill(ds);
            DataTable dt = ds.Tables[0];
            foreach (DataRow dr in dt.Rows)
            {
                boxLoginName.Items.Add(dr["Username"].ToString());
                //cot.boxLoginName.Items.Add(dr["Username"].ToString());
            }
            ms.mcc.Close();
        }
        #endregion
        #region Login Engine SQL Stuff...
        private void boxLoginName_SelectedIndexChanged(object sender, EventArgs e)
        {
            MySqlWrapper ms = new MySqlWrapper();
            string SqlQuery = "SELECT `Password`, `Allowed_Characters`, `Flags` FROM `login` WHERE Username = " + "'" + boxLoginName.Text + "'";
            ms.MySqlRead(SqlQuery);

            while (ms.myreader.Read())
            {
                boxPassword.Text = ms.myreader.GetString(0);
                boxAllowedChars.Text = Convert.ToString(ms.myreader.GetInt32(1));
                boxBanned.Text = Convert.ToString(ms.myreader.GetInt32(2));

            }
            ms.mcc.Close();
            return;
        }
        #endregion
        #region Login Button Stuff for SQL...
        private void btn_Add_Click(object sender, EventArgs e)
        {
            if (boxBanned == null) { boxBanned.Text = "0"; };
            if (boxAllowedChars == null) { boxAllowedChars.Text = "1"; };
            if (boxPassword == null) { MessageBox.Show("Please enter password"); };
            if (boxLoginName.Text == null) { MessageBox.Show("Please enter username"); };
            //string SqlQuery = "INSERT INTO `login`  VALUES(boxLoginName.Text, boxPassword.Text, boxAllowedChars.Text, boxBanned.Text, 122)";
            MySqlWrapper ms = new MySqlWrapper();
            //ms.MySqlInsert();
            //ms.MySqlInsert(SqlQuery);
            ms.mcc.Close();
        }

        private void btn_Update_Click(object sender, EventArgs e)
        {

        }

        private void btn_Delete_Click(object sender, EventArgs e)
        {

        }
        #endregion
        #region Mysql Buttion Section...
        private void btn_Browse_Click(object sender, EventArgs e)
        {

        }

        private void btn_Upload_Click(object sender, EventArgs e)
        {

        }
        #endregion

    }
}
